// IniFileControl.h: CIniFileControl NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_INIFILECONTROL_H__9E5C66C3_4A02_4C0F_A97D_66396A4585E5__INCLUDED_)
#define AFX_INIFILECONTROL_H__9E5C66C3_4A02_4C0F_A97D_66396A4585E5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
//init@C𑀍삵܂B


class CIniFileControl
{
public:
	CIniFileControl(CString appName,CString iniFileName)
	{
		AppName = appName;
		IniFileName = iniFileName;
	};
	CString AppName;
	CString IniFileName;

	//intinit@Cɏ݂܂
	void SetInt(CString keyName,//L[
				int value)//Zbgl
	{
		char work[MAX_PATH];
		WritePrivateProfileString(AppName,keyName,itoa(value,work,10),IniFileName);
	};
	void SetDouble(CString keyName,//L[
				double value)//Zbgl
	{
		char work[MAX_PATH];
#if 1 // 2016.07.15 V2.4.5.0
		_gcvt_s(work,MAX_PATH,value,16);
#else
		_gcvt_s(work,MAX_PATH,value,8);
#endif // 2016.07.15 V2.4.5.0
		WritePrivateProfileString(AppName,keyName,work,IniFileName);
	};


	//floatinit@Cɏ݂܂
	void SetFloat(CString keyName,//L[
				float value)//Zbgl
	{
		char work[MAX_PATH];
		WritePrivateProfileString(AppName,keyName,_gcvt(value,8,work),IniFileName);
	};

	//boolinit@Cɏ݂܂
	void SetBool(CString keyName,//L[
				bool value)//Zbgl
	{
		WritePrivateProfileString(AppName,keyName,value ? "true" : "false",IniFileName);
	};

	//CStringinit@Cɏ݂܂
	void SetString(CString keyName,//L[
				CString value)//Zbgl
	{
		WritePrivateProfileString(AppName,keyName,value,IniFileName);
	};

	//intinit@Cǂݍ
	int GetInt(CString keyName,//L[
				int defValue)//ftHgl
	{
		return GetPrivateProfileInt(AppName,keyName,defValue,IniFileName);
	}
	double GetDouble(CString keyName,//L[
				double defValue)//ftHgl
	{
		char work1[MAX_PATH];
		char work2[MAX_PATH];
		_gcvt_s(work1,MAX_PATH,defValue,8);
		GetPrivateProfileString(AppName,keyName,work1,work2,MAX_PATH,IniFileName);
		return atof(work2);
	}

	//floatinit@Cǂݍ
	float GetFloat(CString keyName,//L[
				float defValue)//ftHgl
	{
		char work1[MAX_PATH];
		char work2[MAX_PATH];
		GetPrivateProfileString(AppName,keyName,_gcvt(defValue,8,work1),work2,MAX_PATH,IniFileName);
		return (float)atof(work2);
	}

	//boolinit@Cǂݍ
	bool GetBool(CString keyName,//L[
				bool defValue)//ftHgl
	{
		char work[MAX_PATH];
		GetPrivateProfileString(AppName,keyName,(defValue?"true":"false"),work,MAX_PATH,IniFileName);
		CString TrueString("true");
		CString CheckString(work);
		return (TrueString == CheckString);
	}

	//CStringinit@Cǂݍ
	CString GetString(CString keyName,//L[
				CString defValue)//ftHgl
	{
		char work[MAX_PATH];
		GetPrivateProfileString(AppName,keyName,defValue,work,MAX_PATH,IniFileName);
		return CString(work);
	}


};

#endif // !defined(AFX_INIFILECONTROL_H__9E5C66C3_4A02_4C0F_A97D_66396A4585E5__INCLUDED_)
