// SviUsbControl.h: CSviUsbControl NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SVIUSBCONTROL_H__19B3D7F6_CEA6_4B17_9A40_CAD728E223C3__INCLUDED_)
#define AFX_SVIUSBCONTROL_H__19B3D7F6_CEA6_4B17_9A40_CAD728E223C3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <vector>
#include "SVI05API.h"

// [15/06/11] Avoid unsafe updating 
#define FPGA_SINGLE_AREA_SIZE (1024*512) // Bytes
#define FX3_SINGLE_AREA_SIZE (1024*512) // Bytes

using namespace std;

//SVIUSB2.0hCoɑ΂鑀bv܂B
class CSviUsbControl
{
public:
	bool close();
//	void SetSelBoardNo(int no);
//	ULONG ulSelBoardNo;
//	ULONG GetDeviceID(int no);
//	ULONG GetBoardNum();
	DWORD ScanBoard();
//	ULONG ulBoardNum;
//	ULONG ulBoardInfo[4];
	//RXgN^
	CSviUsbControl();

	virtual ~CSviUsbControl();

	//SVIhCoI[v܂
	bool open(void);

	//G[R[h擾܂BiG[R[h͏܂B)
	DWORD getLastError(void);

	//G[R[h𕶎ɕϊ܂B
	CString getLastErrorString(DWORD errorcode);

	//JWX^̐ݒ(TuAhXwL)
	bool SetValue(ULONG ulSlaveAdr,ULONG ulSubAdr,PUCHAR pRcvBuff,ULONG ulLen,  int subAddrType);
	// I[vN[Y͊Oōsꍇ
	bool SetValue2(ULONG ulSlaveAdr,ULONG ulSubAdr,PUCHAR pRcvBuff,ULONG ulLen,  BOOL bWord);

	//JWX^̎擾
	bool GetValue(ULONG ulSlaveAdr,ULONG ulSubAdr,PUCHAR pRcvBuff,ULONG ulLen, int subAddrType, BOOL bRestart);
	// I[vN[Y͊Oōsꍇ
	bool GetValue2(ULONG ulSlaveAdr,ULONG ulSubAdr,PUCHAR pRcvBuff,ULONG ulLen, int subAddrType, BOOL bRestart);
	// Read Access ̂
	bool OneBlockRead(ULONG ulSlaveAdr, PUCHAR pRcvBuff, ULONG ulLen);

	// SPIROM̒l擾
	bool SetSVMSettingValue(ULONG ulLen, PUCHAR pRcvBuff);
	// SPIROMl擾
	bool GetSVMSettingValue(ULONG ulLen ,PUCHAR pRcvBuff);

	// SPIROMɂFX3f[^Abvf[g
	bool SVMFx3Update(ULONG ulLen ,PUCHAR pRcvBuff);
	// FPGAUpdates܂
	bool SVMFPGAUpdate(ULONG ulLen ,PUCHAR pRcvBuff);
	
	// [15/06/11
	bool SVMMultiUpdate(ULONG ulLen ,PUCHAR pRcvBuff);

	// SPIROMɂFX3f[^擾
	bool SVMFX3BootMemRead(ULONG ulLen ,PUCHAR pRcvBuff);
	// SPIɂFPGÃu[gpf[^擾܂B
	bool SVMFPGABootMemRead(ULONG ulLen ,PUCHAR pRcvBuff);

	// [15/06/11]
	bool SVMMultiBootMemRead(ULONG ulLen ,PUCHAR pRcvBuff);

	// FX3̃o[W擾
	bool SVMVersionInfo(ULONG ulLen ,PUCHAR pRcvBuff);

	// [17/05/18] Write I2C Initialization Data
	bool WriteInitI2C(ULONG ulLen, PUCHAR pucSendBuf);

	// [17/05/18] Write I2C Initialization Data
	bool ReadInitI2C(ULONG ulLen, PUCHAR pucRcvBuf);
	bool CheckInitI2C();

	// [22/02/18] FPGA Register RW
	bool WriteFPGARegister(ULONG addr, ULONG value);
	bool ReadFPGARegister(ULONG addr, PULONG pValue);
	
	// [23/01/2]3
	bool GetCustomCode(UCHAR cc[4]);	// PubNM
	bool I2CBlockRead(ULONG ulSlaveAdr, ULONG ulSubAdr, ULONG ulLen, PUCHAR pucRcvBuf, BOOL bWord);
	bool I2CDWRead(ULONG ulSlaveAdr, ULONG ulSubAdr, ULONG ulLen, PUCHAR pucRcvBuf);	
	//G[`FbNPiprivate)
	bool CSviUsbControl::checkLastError(void);

	//^[R[h
	DWORD RC;

	// PubNM
	bool I2CBlockWrite(ULONG ulSlaveAdr, ULONG ulSubAdr, ULONG ulLen, PUCHAR pucSendBuf, BOOL bWord);

	// SPIWriteR}hM
	bool SVMSettingWrite(ULONG ulLen, PUCHAR pucSendBuf);
	// SPIReadR}hM
	bool SVMSettingRead(ULONG ulLen, PUCHAR pucRcvBuf);

	// [15/09/02]
	int m_deviceIndex;
	// [18/07/31]
	int m_boardType;
public:
	void SetDeviceIndex(int index){
		m_deviceIndex = index;
	};
	void SetBoardType(int type){
		m_boardType = type;
	};
	bool GetBoardInfo(char* boardInfo, int* pBoardID);
	bool RestartSVM();
	// SV{[hRevisionޔԍ擾
	bool GetRevision(int* svm_03_revision, PUCHAR versionInfo, PUCHAR customCode);
};

#endif // !defined(AFX_SVIUSBCONTROL_H__19B3D7F6_CEA6_4B17_9A40_CAD728E223C3__INCLUDED_)
