// SVIctlDlg.h : wb_[ t@C
//
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "SviUsbControl.h"
#include "MsgDialog.h"
//#include "SVMSettingDlg.h"
#include "SVMSettingInfo.h"
#include <afxmt.h>
#include <vector>
#include <mmsystem.h>	// timeGetTime()
#pragma comment( lib, "winmm.lib" )

using namespace std;

#if !defined(AFX_SVICTLDLG_H__D38F6FBD_CC9E_4A99_B432_A50F6213B516__INCLUDED_)
#define AFX_SVICTLDLG_H__D38F6FBD_CC9E_4A99_B432_A50F6213B516__INCLUDED_

#include "IniFileControl.h"

// t@CtB^
#define STR_FILE_DATFILTER		"Record File (*.dat)|*.dat|"			// Datt@CtB^
#define STR_FILE_BMPFILTER		"Bitmap File (*.bmp)|*.bmp|"			// Bmpt@CtB^
#define STR_FILE_FWFILTER		"Update File (fw*.bin)|fw*.bin|"		// firmwaret@CtB^
//#define STR_FILE_FPGAFILTER		"Update File (fpga*.bin)|fpga*.bin|"	// fpgat@CtB^
#define STR_FILE_DATBMPFILTER	"Record File (*.dat)|*.dat|Bitmap File (*.bmp)|*.bmp|"	// Dat or Bmpt@CtB^
#define STR_FILE_INIFILTER		"Text and Initialize File (*.txt,*.ini)|*.txt;*.ini|CSV File (*.csv)|*.csv|Record File (*.dat)|*.dat|ALL File (*.*)|*.*||"
																		// Datt@CtB^ 2006/1/16 txt gqǉ
#define STR_FILE_INIFILTER2		"Text File (*.txt)|*.txt|ALL File (*.*)|*.*||"
//const CString STR_FILE_FWFILTER = "Update File (so*fw*.bin)|so*fw*.bin|";		///< @brief firmwaret@CtB^
#define STR_FILE_FX3FILTER  "Update File (*.img,*.fx3)|*.img;*.fx3|";		///< @brief firmwaret@CtB^
#define STR_FILE_FPGAFILTER  "Update File (*.bin,*.fpga)|*.bin;*.fpga|";		///< @brief firmwaret@CtB^
#define STR_FILE_MULTIFILTER  "Update File (*.bin,*.multi)|*.bin;*.multi|";		///< @brief firmwaret@CtB^

#define STR_FILE_SVOFILTER  "SVO Setting File (*.svo)|*.svo|";		///< @brief firmwaret@CtB^

//	^C}[
#define READTIMER			100		// ^C}[ID
#define	TIMER_SPEED			1000	// ^C}[x


#define INI_KEY_SLAVE_ADDRESS "SlaveAddress"
#define DEFAULT_SLAVE_ADDRESS ""

#define INI_KEY_SUB_ADDRESS "SubAddress"
#define DEFAULT_SUB_ADDRESS ""

#define INI_KEY_VALUE "Value"
#define DEFAULT_VALUE ""

#define INI_KEY_READ_COUNTS "ReadCounts"
#define DEFAULT_READ_COUNTS ""

#define INI_KEY_REALTIME "RealTime"
#define DEFAULT_REALTIME 0

#define INI_KEY_WORD_ADDRESS "WordAddress"
#define DEFAULT_WORD_ADDRESS 0

#define INI_KEY_WORD_RESTART "Restart"
#define DEFAULT_WORD_RESTART 1


/////////////////////////////////////////////////////////////////////////////
// CSVIctlDlg _CAO

#include "IniFileControl.h"	// ClassView ɂĒǉ܂B
#include "afxwin.h"
class CSVIctlDlg : public CDialog
{
// \z
public:
	bool IsBoardSelected();
	CSVIctlDlg(CWnd* pParent = NULL);	// W̃RXgN^
	CString strRecDataFileName;

// _CAO f[^
	//{{AFX_DATA(CSVIctlDlg)
	enum { IDD = IDD_SVICTL_DIALOG };
	//}}AFX_DATA

protected:
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CSVIctlDlg)
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	HICON m_hIcon;

	// SVIRg[
	CSviUsbControl m_sviUsbControl;

	// i[pobt@
	//vector<UCHAR> RcvBuff;

	// bZ[W\p_CAO
	CMsgDialog MsgDialog;

	// CSV`̃p[X
	int ParseCsv(CString strData, UCHAR* workBuf, ULONG bufSize);

	// CSV`̃p[X 2006.1.13 update
	//	bool ParseCsv(CString strData, UCHAR* workBuf, ULONG bufSize, BOOL bWord);

	// p`FbN
	static bool Checkalnum(LPCTSTR strText,bool cammaflg = false);

	//Xbh֐
	CWinThread *pReadFileThread;
	static UINT CSVIctlDlg::ReadFileThread(LPVOID pMain);


	//init@CŎgp
	CString AppName;//AvP[V
	CString IniFileName;//init@C

//	SVMSettingInfo SVMSettingInfo; // SVMݒli[NX
	//	CSettingDataManager m_settingData;

	//	BOOL SVMSettingSPIRead();
	//	BOOL SVMSettingSPIWrite();


	// ꂽbZ[W }bv֐
	//{{AFX_MSG(CSVIctlDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnWrite();
	afx_msg void OnRead();
	afx_msg void OnOK();
	afx_msg void OnSettingFileWrite();
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	afx_msg void OnClose();
		//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	int LoadPluginDLL();
	
	int GetBoardName(char* boardName, int i);
	int UpdateBoardInfo();
	void UpdateRevisionFromCC(PUCHAR customCode, PUCHAR versionInfo);

	int m_restartCondition;
public:
	CSviUsbControl* GetSviUsbControl();

	CButton m_cButtonSetting;
	CButton m_cButtonSFR;
	CButton m_cButtonWrite;
	CButton m_cButtonRead;
	afx_msg void OnBnClickedWordAddress();
	afx_msg void OnBnClickedBoardPower();
	BOOL m_boardPower;
	afx_msg void OnBnClickedDebug();
	afx_msg void OnBnClickedDebug2();
	afx_msg void OnBnClickedButton1();
	afx_msg void OnBnClickedRestartSvm();
	CButton m_cButtonRestart;
	int m_subAddrType;
	afx_msg void OnBnClickedByteAddress();
	afx_msg void OnBnClickedDwordAddress();
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_SVICTLDLG_H__D38F6FBD_CC9E_4A99_B432_A50F6213B516__INCLUDED_)
